#ifndef WEBCAM_H
#define WEBCAM_H

#include <QtCore/QObject>
#include <QtGui/QImage>
#include <QtCore/QTimer>
#include <QtCore/QMap>

#include <solid/device.h>
#include <solid/video.h>

#include <cv.h>
#include <highgui.h>

class WebCam : public QObject
{
    Q_OBJECT

public:
    explicit WebCam(int interval = 50, QObject *parent = 0);
    ~WebCam();

    void setDevice(const int id);
    void setInterval(const int interval);
    bool isStopped() const;
//     QImage getPreview();
    QMap<int, QString> getCamList() const;


Q_SIGNALS:
    void newFrame(QImage img);

public Q_SLOTS:
    void stop();
    void start();
    void sendNewFrame();

private:
    QImage prepareFrame(IplImage *frame);

    QTimer *timer;
    CvCapture *cam;
    int intervalTime;
    int camId;
    bool stopped;

};
#endif
